using Indotalent.ConfigBackEnd.Exceptions;
using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.CustomerCategory.Cqrs;

public class UpdateCustomerCategoryRequest
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public class UpdateCustomerCategoryResponse
{
    public string? Id { get; set; }
    public bool Success { get; set; }
}

public record UpdateCustomerCategoryCommand(UpdateCustomerCategoryRequest Data) : IRequest<UpdateCustomerCategoryResponse>;

public class UpdateCustomerCategoryHandler : IRequestHandler<UpdateCustomerCategoryCommand, UpdateCustomerCategoryResponse>
{
    private readonly AppDbContext _context;

    public UpdateCustomerCategoryHandler(AppDbContext context) => _context = context;

    public async Task<UpdateCustomerCategoryResponse> Handle(UpdateCustomerCategoryCommand request, CancellationToken cancellationToken)
    {
        var isExists = await _context.CustomerCategory
            .AnyAsync(x => x.Name == request.Data.Name && x.Id != request.Data.Id, cancellationToken);

        if (isExists)
        {
            throw new AlreadyExistsException("Customer Category", request.Data.Name ?? string.Empty);
        }

        var entity = await _context.CustomerCategory
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return new UpdateCustomerCategoryResponse { Id = request.Data.Id, Success = false };
        }

        entity.Name = request.Data.Name;
        entity.Description = request.Data.Description;
        await _context.SaveChangesAsync(cancellationToken);

        return new UpdateCustomerCategoryResponse
        {
            Id = entity.Id,
            Success = true
        };
    }
}